
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Approval_workflowsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const approval_workflows = await db.approval_workflows.create(
            {
                id: data.id || undefined,
        
        workflow_name: data.workflow_name
        ||
        null
            ,
            
        applies_to: data.applies_to
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        description: data.description
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await approval_workflows.setCompany( data.company || null, {
            transaction,
        });
        
        await approval_workflows.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return approval_workflows;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const approval_workflowsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                workflow_name: item.workflow_name
            ||
            null
            ,
            
                applies_to: item.applies_to
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                description: item.description
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const approval_workflows = await db.approval_workflows.bulkCreate(approval_workflowsData, { transaction });

        // For each item created, replace relation files
        

        return approval_workflows;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const approval_workflows = await db.approval_workflows.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.workflow_name !== undefined) updatePayload.workflow_name = data.workflow_name;
        
        
        if (data.applies_to !== undefined) updatePayload.applies_to = data.applies_to;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        updatePayload.updatedById = currentUser.id;

        await approval_workflows.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await approval_workflows.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await approval_workflows.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return approval_workflows;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const approval_workflows = await db.approval_workflows.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of approval_workflows) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of approval_workflows) {
                await record.destroy({transaction});
            }
        });


        return approval_workflows;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const approval_workflows = await db.approval_workflows.findByPk(id, options);

        await approval_workflows.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await approval_workflows.destroy({
            transaction
        });

        return approval_workflows;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const approval_workflows = await db.approval_workflows.findOne(
            { where },
            { transaction },
        );

        if (!approval_workflows) {
            return approval_workflows;
        }

        const output = approval_workflows.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.approval_steps_approval_workflow = await approval_workflows.getApproval_steps_approval_workflow({
            transaction
        });
        
        
        output.approvals_approval_workflow = await approval_workflows.getApprovals_approval_workflow({
            transaction
        });
        
        
        
        
        
        output.company = await approval_workflows.getCompany({
            transaction
        });
        
        
        output.organizations = await approval_workflows.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
        where: filter.company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.company.split('|').map(term => Utils.uuid(term)) } },
            {
              company_name: {
                [Op.or]: filter.company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.workflow_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'approval_workflows',
                        'workflow_name',
                        filter.workflow_name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'approval_workflows',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.applies_to) {
                where = {
                    ...where,
                applies_to: filter.applies_to,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.approval_workflows.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'approval_workflows',
                        'workflow_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.approval_workflows.findAll({
            attributes: [ 'id', 'workflow_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['workflow_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.workflow_name,
        }));
    }

    
};

